import React, { useState } from "react";
import { Link } from "react-router-dom";
import Card from "react-bootstrap/Card";
import Form from "react-bootstrap/Form";
import Button from "react-bootstrap/Button";

const EditableForm = (props) => {
  const {
    problem,
    number,
    onUpdate,
    onRemove,
    handleEditable,
    handleChange,
  } = props;
  return (
    <Form>
      <Form.Group>
        <Form.Control
          value={`${number + 1}번. ${problem.question}`}
          onChange={handleChange}
        />
      </Form.Group>
      Answers
      {problem.answers.map((answer, index) => {
        return (
          <Form.Group key={index}>
            <Form.Control value={answer} onChange={handleChange} />
          </Form.Group>
        );
      })}
      <Button onClick={(event) => onUpdate(number)}>수정</Button>
      <Button onClick={() => onRemove(number)}>삭제</Button>
      <Button onClick={handleEditable}>Editable</Button>
    </Form>
  );
};

const CardForm = (props) => {
  const { problem, number, onUpdate, onRemove, handleEditable } = props;
  return (
    <Card>
      <Card.Body>
        <Card.Title>
          {number + 1}번. {problem.question}
        </Card.Title>
        Answers
        {problem.answers.map((answer, index) => {
          return <Card.Text key={index}>{answer}</Card.Text>;
        })}
        <Button onClick={(event) => onUpdate(number)}>수정</Button>
        <Button onClick={() => onRemove(number)}>삭제</Button>
        <Button onClick={handleEditable}>Editable</Button>
      </Card.Body>
    </Card>
  );
};

function EditableProblem(props) {
  const [editable, setEditable] = useState(false);

  const handleEditable = (event) => {
    setEditable(!editable);
  };

  const handleChange = (event) => {
    const { name, value } = event.target;
    console.log(name, value);
  };

  return (
    <>
      {editable ? (
        <EditableForm
          {...props}
          handleEditable={handleEditable}
          handleChange={handleChange}
        />
      ) : (
        <CardForm
          {...props}
          handleEditable={handleEditable}
          handleChange={handleChange}
        />
      )}
      {/* <Button onClick={handleEditable}>Editable</Button> */}
    </>
    // <Card>
    //   <Card.Body>
    //     <Card.Title>
    //       {/* <EditableText editable={editable}> */}
    //       {number + 1}번. {problem.question}
    //       {/* </EditableText> */}
    //     </Card.Title>
    //     Answers
    //     {problem.answers.map((answer, index) => {
    //       return <Card.Text key={index}>{answer}</Card.Text>;
    //     })}
    //     <Button onClick={(event) => onUpdate(number)}>수정</Button>
    //     <Button onClick={() => onRemove(number)}>삭제</Button>
    //     {/* <EditableText editable={editable} text={"Hello"} /> */}
    //     <Button onClick={handleEditable}>Editable</Button>
    //   </Card.Body>
    // </Card>
  );
}

export default EditableProblem;
